/*
 * LoginAction.java
 *
 * Created on 10. únor 2005, 20:04
 */

package cz.linuxsoft.web.struts.shop.actions;

import cz.linuxsoft.web.authentification.Service;
import cz.linuxsoft.web.struts.shop.consts.Forwards;
import cz.linuxsoft.web.dto.User;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import org.apache.commons.beanutils.BeanUtils;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.action.DynaActionForm;

/**
 * Akce ověří identitu uživatele a uloží jeho data do session
 *
 * @author Miroslav Holubec
 */
public class LoginAction extends Action {
    
    public ActionForward execute(ActionMapping mapping,
            ActionForm form,
            HttpServletRequest request,
            HttpServletResponse response)
            throws Exception {
        //vytvořím novou instanci User DTO
        User user=new User();
        //přetypování formu na DynaActionForm
        DynaActionForm inputForm=(DynaActionForm) form;
        //zkopírování hodnot formu do DTO objektu
        BeanUtils.copyProperties(user, inputForm);
        //provedení samotné business logiky
        Service service=new Service();
        //validace proběhne úspěšně pokud služba nehodí exception
        user=service.validate(user);
        //vytvoř novou session
        HttpSession session = request.getSession(false);
        if (session!=null)
            session.invalidate();
        session=request.getSession(true);
        //ulož uživatelská data do session
        session.setAttribute("user", user);
        return(mapping.findForward(Forwards.SUCCESS));
    }
}
